%if 0%{?fedora} > 0 || 0%{?rhel} > 6
%global with_systemd 1
%global with_sysvinit 0
%else
%global with_systemd 0
%global with_sysvinit 1
%endif


Name:           sympa
Version:        6.1.23
Release:        1%{?dist}
Summary:        Mailing list manager

Group:          System Environment/Daemons
License:        GPLv2+
URL:            http://www.sympa.org
Source0:        http://www.sympa.org/distribution/sympa-%{version}.tar.gz
Source1:        sympa-httpd.conf
Source2:        sympa-logrotate.conf
Source3:        sympa-initscript
Source4:        sympa-mail_aliases
Source10:       sympa-archived.service
Source11:       sympa-bounced.service
Source12:       sympa-bulk.service
Source13:       sympa-sympa.service
Source14:       sympa-task_manager.service

BuildRequires:  gettext
%if %{with_sysvinit}
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%endif
%if %{with_systemd}
BuildRequires: systemd-units
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
%endif

Requires:        mod_fcgid
Requires:        perl(CGI)
Requires:        perl(DBD::mysql)
Requires:        perl(FCGI)
Requires:        perl(LWP)
Requires:        perl(Locale::TextDomain)
Requires:        perl(MHonArc::UTF8)

# OPTIONAL modules:
Requires:        perl(AuthCAS)
Requires:        perl(Crypt::CipherSaber)
Requires:        perl(File::NFSLock)
Requires:        perl(IO::Socket::SSL)
Requires:        perl(Mail::DKIM)
Requires:        perl(Net::SMTP)
#Requires:        perl(DBD::Pg)
Requires:        perl(DBD::SQLite)
Requires:        perl(DBD::ODBC)

%if 0%{?rhel} > 5
%filter_provides_in %{_datadir}/%{name}/lib/
%filter_from_requires /perl(admin)/d
%filter_from_requires /perl(Archive)/d
%filter_from_requires /perl(Auth)/d
%filter_from_requires /perl(Bounce)/d
%filter_from_requires /perl(Bulk)/d
%filter_from_requires /perl(Commands)/d
%filter_from_requires /perl(Conf)/d
%filter_from_requires /perl(confdef)/d
%filter_from_requires /perl(Config_XML)/d
%filter_from_requires /perl(cookielib)/d
%filter_from_requires /perl(Datasource)/d
%filter_from_requires /perl(Family)/d
%filter_from_requires /perl(Fetch)/d
%filter_from_requires /perl(HTML::myFormatText)/d
%filter_from_requires /perl(Language)/d
%filter_from_requires /perl(Ldap)/d
%filter_from_requires /perl(LDAPSource)/d
%filter_from_requires /perl(List)/d
%filter_from_requires /perl(Lock)/d
%filter_from_requires /perl(Log)/d
%filter_from_requires /perl(mail)/d
%filter_from_requires /perl(Marc)/d
%filter_from_requires /perl(Marc::Search)/d
%filter_from_requires /perl(Message)/d
%filter_from_requires /perl(PlainDigest)/d
%filter_from_requires /perl(report)/d
%filter_from_requires /perl(Robot)/d
%filter_from_requires /perl(Scenario)/d
%filter_from_requires /perl(SharedDocument)/d
%filter_from_requires /perl(SOAP::Transport::HTTP::FCGI::Sympa)/d
%filter_from_requires /perl(SOAP::XMLSchema1999::Serializer)/d
%filter_from_requires /perl(SQLSource)/d
%filter_from_requires /perl(Sympa::Constants)/d
%filter_from_requires /perl(SympaSession)/d
%filter_from_requires /perl(sympasoap)/d
%filter_from_requires /perl(SympaTransport)/d
%filter_from_requires /perl(Sympa::Template::Compat)/d
%filter_from_requires /perl(Task)/d
%filter_from_requires /perl(time_utils)/d
%filter_from_requires /perl(tools)/d
%filter_from_requires /perl(tt2)/d
%filter_from_requires /perl(Upgrade)/d
%filter_from_requires /perl(WebAgent)/d
%filter_from_requires /perl(wwslib)/d
%filter_setup
%endif

%if 0%{?fedora}
%{?filter_setup:
%filter_provides_in %{_datadir}/%{name}/lib/
%filter_from_requires /perl\\(admin\\)/d
%filter_from_requires /perl\\(Archive\\)/d
%filter_from_requires /perl\\(Auth\\)/d
%filter_from_requires /perl\\(Bounce\\)/d
%filter_from_requires /perl\\(Bulk\\)/d
%filter_from_requires /perl\\(Commands\\)/d
%filter_from_requires /perl\\(Conf\\)/d
%filter_from_requires /perl\\(confdef\\)/d
%filter_from_requires /perl\\(Config_XML\\)/d
%filter_from_requires /perl\\(cookielib\\)/d
%filter_from_requires /perl\\(Datasource\\)/d
%filter_from_requires /perl\\(Family\\)/d
%filter_from_requires /perl\\(Fetch\\)/d
%filter_from_requires /perl\\(HTML::myFormatText\\)/d
%filter_from_requires /perl\\(Language\\)/d
%filter_from_requires /perl\\(Ldap\\)/d
%filter_from_requires /perl\\(LDAPSource\\)/d
%filter_from_requires /perl\\(List\\)/d
%filter_from_requires /perl\\(Lock\\)/d
%filter_from_requires /perl\\(Log\\)/d
%filter_from_requires /perl\\(mail\\)/d
%filter_from_requires /perl\\(Marc\\)/d
%filter_from_requires /perl\\(Marc::Search\\)/d
%filter_from_requires /perl\\(Message\\)/d
%filter_from_requires /perl\\(PlainDigest\\)/d
%filter_from_requires /perl\\(report\\)/d
%filter_from_requires /perl\\(Robot\\)/d
%filter_from_requires /perl\\(Scenario\\)/d
%filter_from_requires /perl\\(SharedDocument\\)/d
%filter_from_requires /perl\\(SOAP::Transport::HTTP::FCGI::Sympa\\)/d
%filter_from_requires /perl\\(SOAP::XMLSchema1999::Serializer\\)/d
%filter_from_requires /perl\\(SQLSource\\)/d
%filter_from_requires /perl\\(Sympa::Constants\\)/d
%filter_from_requires /perl\\(SympaSession\\)/d
%filter_from_requires /perl\\(sympasoap\\)/d
%filter_from_requires /perl\\(SympaTransport\\)/d
%filter_from_requires /perl\\(Sympa::Template::Compat\\)/d
%filter_from_requires /perl\\(Task\\)/d
%filter_from_requires /perl\\(time_utils\\)/d
%filter_from_requires /perl\\(tools\\)/d
%filter_from_requires /perl\\(tt2\\)/d
%filter_from_requires /perl\\(Upgrade\\)/d
%filter_from_requires /perl\\(WebAgent\\)/d
%filter_from_requires /perl\\(wwslib\\)/d
}
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}%{_datadir}/%{name}/lib/
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(admin\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Archive\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Auth\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Bounce\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Bulk\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Commands\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Conf\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(confdef\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Config_XML\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(cookielib\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Datasource\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Family\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Fetch\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(HTML::myFormatText\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Language\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Ldap\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(LDAPSource\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(List\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Lock\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Log\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(mail\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Marc\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Marc::Search\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Message\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(PlainDigest\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(report\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Robot\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Scenario\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(SharedDocument\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(SOAP::Transport::HTTP::FCGI::Sympa\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(SOAP::XMLSchema1999::Serializer\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(SQLSource\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Sympa::Constants\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(SympaSession\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(sympasoap\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(SympaTransport\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Sympa::Template::Compat\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Task\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(time_utils\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(tools\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(tt2\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(Upgrade\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(WebAgent\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(wwslib\\)
%endif


%description
Sympa is an opensource mailing list manager. It provides a powerful list server
including a lot of features via a web interface.

- high performance for huge lists ( > 700.000 subscribers)
- Mime compatible
- data provisioning using LDAP, SQL or other data sources
- various authentication method (SSO, LDAP, X509)
- benefit of S/MIME and DKIM
- internationalized
- web archive with access control, message removal etc
- multi-domain server designed for service providers.
- sophisticated automatic bounce management
- automatic service message and web interface customizable
- SOAP interface for integration with other applications


%prep
%setup -q
# Fix file encoding
for i in AUTHORS ChangeLog NEWS README; do
        iconv -f iso8859-1 -t utf-8 $i > $i.utf8 && \
        touch -r $i $i.utf8 && \
        mv -f $i.utf8 $i;
done;


%build
%configure \
    --enable-fhs \
    --sysconfdir=%{_sysconfdir}/%{name} \
    --docdir=%{_defaultdocdir}/%{name}-%{version} \
    --with-expldir=%{_localstatedir}/lib/%{name}/expl \
    --with-initdir=%{_initrddir} \
    --with-defaultdir=%{_datadir}/%{name}/default \
    --with-staticdir=%{_datadir}/%{name}/static_content

make %{?_smp_mflags}

# Fix manpage encoding after make did all its magic
# Fixing it in the %%prep section doesn't work for some reason
pushd doc/man8
for i in alias_manager.8 archived.8 bounced.8 sympa.8; do
        touch -r $i $i.utf8 && \
        iconv -f iso8859-1 -t utf-8 $i > $i.utf8 && \
        mv -f $i.utf8 $i;
done
popd


%install
make install DESTDIR=$RPM_BUILD_ROOT
%find_lang %{name}
%find_lang web_help
cat web_help.lang >> %{name}.lang

# Install http conf
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
sed -e 's.@@libdir@@.%{_libdir}.' %{SOURCE1} > \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/%{name}.conf

# Install logrotate conf
# Note : The conf file is now patched to use the mail facility, so the logrotate conf
#        is now useless.
#install -Dp -m 0644 %{SOURCE2} \
#    $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d/%{name}

# Install initscript
%if %{with_sysvinit}
install -Dp -m 0755 %{SOURCE3} $RPM_BUILD_ROOT/%{_initrddir}/%{name}
%endif

# Install systemd unit file
%if %{with_systemd}
install -Dp -m 0644 %{SOURCE10} $RPM_BUILD_ROOT/%{_unitdir}/%{name}-archived.service
install -Dp -m 0644 %{SOURCE11} $RPM_BUILD_ROOT/%{_unitdir}/%{name}-bounced.service
install -Dp -m 0644 %{SOURCE12} $RPM_BUILD_ROOT/%{_unitdir}/%{name}-bulk.service
install -Dp -m 0644 %{SOURCE13} $RPM_BUILD_ROOT/%{_unitdir}/%{name}.service
install -Dp -m 0644 %{SOURCE14} $RPM_BUILD_ROOT/%{_unitdir}/%{name}-task_manager.service
rm -f $RPM_BUILD_ROOT/%{_initrddir}/%{name}
%endif

# Install mail aliases file
install -Dp -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/mail/sympa_aliases

# sendmail secure shell
mkdir -p $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_libexecdir}/queue $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_libexecdir}/bouncequeue $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_libexecdir}/familyqueue $RPM_BUILD_ROOT/etc/smrsh

# Create bounce and archives directories
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/{arc,bounce}

# Create spool directories
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/spool/%{name}/{msg,bounce,automatic,digest,moderation,topic,auth,outgoing,task,subscribe}

# Autogenerated stuff that needs to be owned by sympa
touch $RPM_BUILD_ROOT%{_datadir}/%{name}/static_content/index.html
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/static_content/{css,pictures}

# Fix perms 
chmod a-x $RPM_BUILD_ROOT%{_datadir}/%{name}/bin/create_db.*

# Tweak sympa.conf
sed -i -e 's/host\.domain\.tld/localhost.localdomain/' \
       -e 's/domain\.tld/localhost.localdomain/' \
       -e 's/your_email_address/root/' \
       $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/sympa.conf 

# Use the mail facility for sympa logs
sed -i -e 's/^syslog\tLOCAL1/syslog mail/' \
       $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/sympa.conf
sed -i -e 's/^syslog\tLOCAL1/#syslog mail/' \
       $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/wwsympa.conf

# Clean up useless files
rm doc/sample/Makefile*
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%pre
getent group sympa >/dev/null || groupadd -r sympa
getent passwd sympa >/dev/null || \
useradd -r -g sympa -d /var/lib/sympa -s /sbin/nologin \
        -c "User for the sympa mailing list manager" sympa
exit 0

%post
%if %{with_sysvinit}
/sbin/chkconfig --add %{name}
%endif
%if %{with_systemd}
%systemd_post sympa.service
%endif

%preun
%if %{with_sysvinit}
if [ $1 = 0 ] ; then
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi
%endif
%if %{with_systemd}
%systemd_preun sympa.service
%endif

%postun
%if %{with_sysvinit}
if [ "$1" -ge 1 ]; then
  if %{_sbindir}/sympa.pl --check_auto_upgrade; then
    if [ -e %{_localstatedir}/lock/subsys/sympa ]; then
      /sbin/service sympa stop > /dev/null 2>&1
      if %{_sbindir}/sympa.pl --upgrade; then
        %{_sbindir}/sympa.pl --sync_list_db || true
        /sbin/service sympa start > /dev/null 2>&1
      fi
    else
      if %{_sbindir}/sympa.pl --upgrade; then
        %{_sbindir}/sympa.pl --sync_list_db || true
      fi
    fi
  fi
fi
%endif

%if %{with_systemd}
%systemd_postun sympa.service 
if [ "$1" -ge 1 ]; then
  if %{_sbindir}/sympa.pl --check_auto_upgrade; then
    if /usr/bin/systemctl is-active sympa.service; then
      /usr/bin/systemctl stop sympa.service > /dev/null 2>&1
      if %{_sbindir}/sympa.pl --upgrade; then
        %{_sbindir}/sympa.pl --sync_list_db || true
        /usr/bin/systemctl start sympa.service /dev/null 2>&1 || :
      fi
    else
      if %{_sbindir}/sympa.pl --upgrade; then
        %{_sbindir}/sympa.pl --sync_list_db || true
      fi
    fi
  fi
fi
%endif


%files -f %{name}.lang
%doc AUTHORS ChangeLog COPYING doc/sample NEWS README README.charset
%{_mandir}/man?/*
%if %{with_sysvinit}
%{_initrddir}/%{name}
%endif
%if %{with_systemd}
%{_unitdir}/%{name}*.service
%endif
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
#%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/mail/sympa_aliases
%{_sysconfdir}/smrsh/*

%dir %{_sysconfdir}/%{name}/
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/%{name}/data_structure.version
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/%{name}/sympa.conf
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/%{name}/wwsympa.conf
%{_sysconfdir}/%{name}/README

%dir %{_libdir}/%{name}/
%dir %{_libdir}/%{name}/cgi/
%{_libdir}/%{name}/cgi/sympa_soap_server.fcgi
%attr(4755,sympa,root) %{_libdir}/%{name}/cgi/sympa_soap_server-wrapper.fcgi
%{_libdir}/%{name}/cgi/wwsympa.fcgi
%attr(4755,sympa,root) %{_libdir}/%{name}/cgi/wwsympa-wrapper.fcgi
%attr(4755,sympa,sympa) %{_libexecdir}/bouncequeue
%attr(4755,sympa,sympa) %{_libexecdir}/familyqueue
%attr(4755,sympa,sympa) %{_libexecdir}/queue
%attr(4755,sympa,sympa) %{_libexecdir}/sympa_newaliases-wrapper
#%attr(4750,root,sympa) %{_sbindir}/aliaswrapper
#%attr(4750,root,sympa) %{_sbindir}/virtualwrapper
%{_sbindir}/alias_manager.pl
%{_sbindir}/archived.pl
%{_sbindir}/bounced.pl
%{_sbindir}/bulk.pl
%{_sbindir}/sympa.pl
%{_sbindir}/sympa_newaliases.pl
%{_sbindir}/sympa_wizard.pl
%{_sbindir}/task_manager.pl

%dir %{_datadir}/%{name}/
%{_datadir}/%{name}/bin/
%{_datadir}/%{name}/lib/
%{_datadir}/%{name}/default/
%dir %{_datadir}/%{name}/static_content/
%{_datadir}/%{name}/static_content/icons/
%attr(-,sympa,root) %{_datadir}/%{name}/static_content/index.html
%dir %attr(-,sympa,root) %{_datadir}/%{name}/static_content/css/
%dir %attr(-,sympa,root) %{_datadir}/%{name}/static_content/pictures/
%attr(-,sympa,root) %{_localstatedir}/lib/%{name}/
%attr(-,sympa,root) %{_localstatedir}/spool/%{name}/


%changelog
* Mon Dec 08 2014 Xavier Bachelot <xavier@bachelot.org> 6.1.23-1
- Update to 6.1.23.
- Fix conditional to select systemd or sysvinit.

* Mon Jun 09 2014 Xavier Bachelot <xavier@bachelot.org> 6.1.22-1
- Update to 6.1.22.
- Add Requires: on optional perl module DBD::ODBC.
- Fix httpd conf to support httpd 2.4.

* Wed Jun 04 2014 Xavier Bachelot <xavier@bachelot.org> 6.1.20-1
- Update to 6.1.20.

* Fri Feb 07 2014 Xavier Bachelot <xavier@bachelot.org> 6.1.19-1
- Update to 6.1.19.
- Drop upstreamed patch.
- TODO: Modernize specfile and drop support for EL 5.

* Mon Sep 30 2013 Xavier Bachelot <xavier@bachelot.org> 6.1.17-1
- Update to 6.1.17.
- Drop upstreamed patch.

* Mon May 14 2012 Xavier Bachelot <xavier@bachelot.org> 6.1.11-1
- Update to 6.1.11.
- Drop upstreamed patch.
- Add patch to fix broken --with-staticdir configure option.
- Add patch to fix outdated FSF address.

* Tue Apr 17 2012 Xavier Bachelot <xavier@bachelot.org> 6.1.9-1
- Update to 6.1.9.

* Mon Nov 28 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.7-3
- Systemd support.

* Mon Nov 28 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.7-2
- Improve Requires/Provides filtering.
- Use ScriptAlias rather than Alias for /sympa in httpd conf.
- Handle upgrades.
- Don't provide INSTALL file.

* Fri Aug 26 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.7-1
- Update to 6.1.7.

* Sat Jul 23 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.6-1
- Update to 6.1.6.

* Tue Jun 28 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.5-1
- Update to 6.1.5.

* Thu May 12 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.4-1
- Initial Fedora release.
